//+------------------------------------------------------------------+
//|                                              @MTF_Stochastic.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//| added 1 more stochastics-5-30-2014 RK
//|
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window

#property indicator_buffers 2
//#property indicator_color1 Blue //Yellow
//#property indicator_color2 EMPTY 
//#property indicator_width1 3

#property indicator_level1 90
#property indicator_level2 10
#property indicator_level3 70
#property indicator_level4 30
#property indicator_levelcolor Peru

#property indicator_maximum 120
#property indicator_minimum -10

extern int TimeFrame  = 0;
extern int KPeriod    = 7;
extern int DPeriod    = 1;
extern int Slowing    = 2;
extern int MAMethod   = 3;
extern int PriceField = 1;
extern int NumBars    = 999;

double ExtMapBuffer1[];
double ExtMapBuffer2[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

   SetIndexBuffer(0,ExtMapBuffer1);
   
   if(TimeFrame ==0)    SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,3, Blue);// Line style
   if(TimeFrame ==15)   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,3, RosyBrown);// Line style
   if(TimeFrame ==30)   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,3, Salmon);// Line style
   if(TimeFrame ==60)   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,3, Cyan);// Line style
   if(TimeFrame ==240)  SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,3, LawnGreen);// Line style
   if(TimeFrame ==1440) SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,3, Yellow);// Line style
   if(TimeFrame ==10080)SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,3, OrangeRed);// Line style
   
   
   
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(1,EMPTY);   
   SetIndexLabel(0,"b0-Sto-"+TimeFrame+", K-"+KPeriod+", S-"+Slowing);
   SetIndexLabel(1,NULL);
   
   
   
   
//---- name for DataWindow and indicator subwindow label   
   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="M1"; break;
      case 5 : TimeFrameStr="M5"; break;
      case 15 : TimeFrameStr="M15"; break;
      case 30 : TimeFrameStr="M30"; break;
      case 60 : TimeFrameStr="H1"; break;
      case 240 : TimeFrameStr="H4"; break;
      case 1440 : TimeFrameStr="D1"; break;
      case 10080 : TimeFrameStr="W1"; break;
      case 43200 : TimeFrameStr="MN1"; break;
      default : TimeFrameStr="Current";
   } 
   IndicatorShortName("RK-han-Stochastic " + TimeFrameStr + " ("+KPeriod+","+DPeriod+","+Slowing+") ");  
//	IndicatorShortName("");  //----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 

   int j=0;
   for(int i=0; i<=Bars; i++)  {
     while(Time[i]<TimeArray[j]) j++;
     if(j>ArraySize(TimeArray))  break;
     if(i>NumBars)  break;
     ExtMapBuffer1[i]=iStochastic(NULL,TimeFrame,KPeriod,DPeriod,Slowing,MAMethod,PriceField,0,j);
     ExtMapBuffer2[i]=iStochastic(NULL,TimeFrame,KPeriod,DPeriod,Slowing,MAMethod,PriceField,1,j);
   }
   return(0);
  }
//+------------------------------------------------------------------+